(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
Clear[addToGlobalAssumptions]
addToGlobalAssumptions[listOfStatements_,debug_:False,resetExistingAssumptions_:False]:=(
(*when there are no global assumptions, $Assumptions=True, which can also be used to reset the global assumptions*)
If[resetExistingAssumptions,$Assumptions=True];
Do[
Block[
{statement=listOfStatements[[i]]},
If[debug,Print[statement, Not[MemberQ[$Assumptions,statement]], $Assumptions===True]];
If[
Not[MemberQ[$Assumptions,statement]],
If[
$Assumptions===True,
If[debug,Print[{statement}]];
$Assumptions={statement},
(*add to the existing global assumptions unless already present therein*)
If[debug,Print[Join[$Assumptions,{statement}]]];
$Assumptions=Join[$Assumptions,{statement}]
]
];
],
{i,1,Length[listOfStatements]}
];
)


(* ::Input::Initialization:: *)
FullSimplifyTimeConstrained[f_,timeConstraint_:{1,10}]:=FullSimplify[f,TimeConstraint->timeConstraint];


(* ::Input::Initialization:: *)
(*for nice printing of sqrt*)
cleanUpSqrt[expr_,print_:False]:=(
cleanerExpr=Sqrt[expr^2//Together//FullSimplify]//FullSimplify;If[print,cleanerExpr//Print,cleanerExpr//Return]
)


(* ::Code::Initialization:: *)
(*replacement rule for Conjugate[_], i.e. use as expression/.ConjugateFlipI, to simplify if all variables are real using the theorem
that conjugation commutes with any holomorphic function that is real-valued on the reals*)
ConjugateFlipI = Conjugate[f_]:>(f/.{I->-I,Complex[RePart_,ImPart_]->Complex[RePart,-ImPart]});
ConjugateTransposeFlipI[matrix_]:=ConjugateTranspose[matrix]/.ConjugateFlipI
(*only use FlipI functions to find |expr|^2 if all variables are real*)
AbsSqrFlipI[expr_]:=expr Conjugate[expr]/.ConjugateFlipI
AbsFlipI[expr_]:=Sqrt[AbsSqrFlipI[expr]]//FullSimplifyTimeConstrained


(* ::Input::Initialization:: *)
findCommonFactor[tensor_?TensorQ,returnInactivated_:True,mapInFactor_:None,factorFactor_:False]:=Block[
{GCDListv,cfactor,tenfact,tenfactmf,facten},
(*Find the common factor among elements of a vector or matrix;
From https://mathematica.stackexchange.com/a/262273;
TODO: extract Sqrt[2] common from {2 a, Sqrt[2]b};
TODO: extract \[ImaginaryI]*)
cfactor:=PolynomialGCD@@Flatten@tensor//FullSimplify;
tenfact:=(1/cfactor)tensor//FullSimplify;
tenfactmf:=tenfact//MatrixForm;
If[Not[mapInFactor===None],cfactorMapped=cfactor/.mapInFactor//FullSimplify,cfactorMapped=cfactor];
If[factorFactor,cfactorMapped=cfactorMapped//Factor];
Piecewise[{
{Return[If[returnInactivated,Inactivate[cfactorMapped tenfactmf],{cfactorMapped,tenfact}]],cfactor=!=1},
(*{Print["The tensor cannot be expressed as a multiple of another tensor"],cfactor===1}*)
{Return[If[returnInactivated,Inactivate[tenfactmf],tenfactmf]],cfactor===1}
}];
];
(*A better name to use. TODO: sed the repo/s to replace every findCommonFactor by a MatrixFactor*)
(*TODO: If there is no good common factor, then just return MatrixForm*)
MatrixFactor=findCommonFactor;

findCoeffs[expr_,inputs_,print_:False,quantityName_:None,simplify_:True]:=(
(*Return the coefficients of an expr as a linear combination of given inputs, optionally print the result.*)
Block[{coeffs},
coeffs=Coefficient[expr,inputs];
If[simplify,
coeffs=coeffs//FullSimplifyTimeConstrained;
(*TODO: fix check to determine if an input, e.g. h, is missing from the quantity*)
If[expr-coeffs.inputs!=0//FullSimplifyTimeConstrained,
Throw["Missing input."]
];
];
If[print,
Print[quantityName," = ",{coeffs}//MatrixFactor,".",inputs//MatrixFactor]
];
Return[coeffs];
];
)
find\[LetterSpace]coefficients=findCoeffs;


(* ::Input::Initialization:: *)
colourBoolForPrint[bool_]:=(
colour=If[bool,Green,Red];
Return[Style[bool,colour]]
)


(* ::Input::Initialization:: *)
fromLaTeX[stringWithBackslashesEscaped_]:=ToExpression[stringWithBackslashesEscaped,TeXForm]


(* ::Input::Initialization:: *)
Clear[MatrixVectorise]
MatrixVectorise[A_]:=(
(*Vectorise a matrix by stacking the column vectors on top of each other.;
For use with the Kronecker product to solve matrix equations.;
Fast solution from <https://mathematica.stackexchange.com/a/185343>.;*)
ArrayReshape[Transpose[A],{Times@@Dimensions[A],1}]
)

Clear[MatrixUnvectorise]
MatrixUnvectorise[v_,num\[LetterSpace]rows_:2,num\[LetterSpace]cols_:2]:=(
(*Invert MatrixVectorise[].*)
If[{num\[LetterSpace]rows num\[LetterSpace]cols,1}!=Dimensions[v]&&{num\[LetterSpace]rows num\[LetterSpace]cols}!=Dimensions[v],
Throw["MatrixUnvectorise: Dimension mismatch (may have assumed 2 by 2)."];
];
If[num\[LetterSpace]cols==num\[LetterSpace]rows,
vec=Flatten[v];
unwrap[i_]:=QuotientRemainder[i-1,num\[LetterSpace]cols]+{1,1}//Reverse;
matrix=Table[None,{j,1,num\[LetterSpace]cols},{k,1,num\[LetterSpace]cols}];
Do[
{j,k}=unwrap[i];
matrix[[j,k]]=vec[[i]],
{i,1,Length[vec]}
];
Return[matrix];,
Throw["MatrixUnvectorise: need map defined for non-square matrix."];
]
)
